/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Mem.xs. Do not edit this file, edit Mem.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Linux/FD/Mem.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <sys/mman.h>
#include <sys/syscall.h>
#include <linux/memfd.h>

#define die_sys(format) Perl_croak(aTHX_ format, strerror(errno))

static SV* S_io_fdopen(pTHX_ int fd, const char* classname, char type) {
	PerlIO* pio = PerlIO_fdopen(fd, "r");
	GV* gv = newGVgen(classname ? classname : "Linux::FD::Mem");
	SV* ret = newRV_noinc((SV*)gv);
	IO* io = GvIOn(gv);
	IoTYPE(io) = type;
	IoIFP(io) = pio;
	IoOFP(io) = pio;
	if (classname) {
		HV* stash = gv_stashpv(classname, FALSE);
		sv_bless(ret, stash);
	}
	return ret;
}
#define io_fdopen(fd, classname, type) S_io_fdopen(aTHX_ fd, classname, type)

typedef struct { const char* key; size_t length; int value; } map[];

static const map mem_flags = {
	{ STR_WITH_LEN("allow-sealing"), MFD_ALLOW_SEALING },
#ifdef MFD_HUGETLB
	{ STR_WITH_LEN("huge-table"), MFD_HUGETLB },
	{ STR_WITH_LEN("huge-2mb"), MFD_HUGE_2MB },
	{ STR_WITH_LEN("huge-1gb"), MFD_HUGE_1GB },
#endif
};

static UV S_get_mem_flag(pTHX_ SV* flag_name) {
	int i;
	for (i = 0; i < sizeof mem_flags / sizeof *mem_flags; ++i)
		if (strEQ(SvPV_nolen(flag_name), mem_flags[i].key))
			return mem_flags[i].value;
	Perl_croak(aTHX_ "No such flag '%s' known", SvPV_nolen(flag_name));
}
#define get_mem_flag(name) S_get_mem_flag(aTHX_ name)

static const map seal_flags = {
	{ STR_WITH_LEN("seal"), F_SEAL_SEAL },
	{ STR_WITH_LEN("shrink"), F_SEAL_SHRINK },
	{ STR_WITH_LEN("grow"), F_SEAL_GROW },
	{ STR_WITH_LEN("write"), F_SEAL_WRITE },
#ifdef F_SEAL_FUTURE_WRITE
	{ STR_WITH_LEN("future-write"), F_SEAL_FUTURE_WRITE },
#endif
};

static UV S_get_seal_flag(pTHX_ SV* flag_name) {
	int i;
	for (i = 0; i < sizeof seal_flags / sizeof *seal_flags; ++i)
		if (strEQ(SvPV_nolen(flag_name), seal_flags[i].key))
			return seal_flags[i].value;
	Perl_croak(aTHX_ "No such seal '%s' known", SvPV_nolen(flag_name));
}
#define get_seal_flag(name) S_get_seal_flag(aTHX_ name)

#define get_fd(self) PerlIO_fileno(IoOFP(sv_2io(SvRV(self))))

#line 79 "lib/Linux/FD/Mem.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 223 "lib/Linux/FD/Mem.c"

XS_EUPXS(XS_Linux__FD__Mem_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Mem_new)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "classname, name, ...");
    {
	const char*	classname = (const char *)SvPV_nolen(ST(0))
;
	const char*	name = (const char *)SvPV_nolen(ST(1))
;
#line 76 "lib/Linux/FD/Mem.xs"
	int memfd;
	int i, flags = MFD_CLOEXEC;
#line 239 "lib/Linux/FD/Mem.c"
	SV *	RETVAL;
#line 79 "lib/Linux/FD/Mem.xs"
	for (i = 2; i < items; i++)
		flags |= get_mem_flag(ST(i));
	memfd = syscall(__NR_memfd_create, name, flags);
	if (memfd < 0)
		die_sys("Couldn't open memfd: %s");
	RETVAL = io_fdopen(memfd, classname, '+');
#line 248 "lib/Linux/FD/Mem.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Mem_seal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Mem_seal)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "file_handle, ...");
    {
	SV*	file_handle = ST(0)
;
#line 92 "lib/Linux/FD/Mem.xs"
		int fd, seals = 0, i, ret;
#line 267 "lib/Linux/FD/Mem.c"
#line 94 "lib/Linux/FD/Mem.xs"
	fd = get_fd(file_handle);
	for (i = 1; i < items; i++)
		seals |= get_seal_flag(ST(i));
	ret = fcntl(fd, F_ADD_SEALS, seals);
	if (ret < 0)
		die_sys("Couldn't add seal: %s");
#line 275 "lib/Linux/FD/Mem.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__FD__Mem_get_seals); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Mem_get_seals)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "file_handle");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	file_handle = ST(0)
;
#line 105 "lib/Linux/FD/Mem.xs"
	int seals, fd, i;
#line 294 "lib/Linux/FD/Mem.c"
#line 107 "lib/Linux/FD/Mem.xs"
	fd = get_fd(file_handle);
	seals = fcntl(fd, F_GET_SEALS, 0);
	for (i = 0; i < sizeof seal_flags / sizeof *seal_flags; ++i) {
		if (seal_flags[i].value & seals)
			mXPUSHp(seal_flags[i].key, seal_flags[i].length);
	}
#line 302 "lib/Linux/FD/Mem.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Linux__FD__Mem); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Linux__FD__Mem)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Linux::FD::Mem::new", XS_Linux__FD__Mem_new);
        newXS_deffile("Linux::FD::Mem::seal", XS_Linux__FD__Mem_seal);
        newXS_deffile("Linux::FD::Mem::get_seals", XS_Linux__FD__Mem_get_seals);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
